#include "geki5.h"
#define _EXTERN_DEF_
#include "extern.h"

//========================================
// ᥤ롼
//========================================
void MainLoop(void)
{
  KXL_Rect rect={UP_TOP, UP_LEFT, WIDTH, HEIGHT};

  while (1) {
    // ޳Ԥ
    if (KXL_GetTimer() == False)
      continue;
    // ޥꥻå
    KXL_ResetTimer();
    // ٥Ƚ
    while (KXL_CheckEvents()) {
      switch (KXL_GetEvents()) {
	// 
      case KXL_EVENT_KEY_PRESS:
        switch (KXL_GetKey()) {
        case KeyShot:  Root->Key |= KShot;  break;
        case KeyLeft:  Root->Key |= KLeft;  break;
        case KeyRight: Root->Key |= KRight; break;
        case KeyUp:    Root->Key |= KUp;    break;
        case KeyDown:  Root->Key |= KDown;  break;
        case KeyPause: Root->Key |= KPause; break;
        case KeyQuit:
	  KXL_PlaySound(SE_BGM, KXL_SOUND_STOP_ALL);
	  Root->MainFlag = MainOpening;
	  Root->Cnt = 0;
	  break;
        default:                            break;
        }
        break;
	// Υ
      case KXL_EVENT_KEY_RELEASE:
        switch (KXL_GetKey()) {
        case KeyShot:  Root->Key &= KShotMask;  break;
        case KeyLeft:  Root->Key &= KLeftMask;  break;
        case KeyRight: Root->Key &= KRightMask; break;
        case KeyUp:    Root->Key &= KUpMask;    break;
        case KeyDown:  Root->Key &= KDownMask;  break;
        case KeyPause: Root->Key &= KPauseMask; break;
        default:                                break;
        }
        break;
      default:
        break;
      }
    }
    // ե졼९ꥢ
    KXL_ClearFrame(rect);
    // ط
    KXL_PutImage(PixBack, UP_LEFT, UP_TOP);
    // ᥤ
    switch (Root->MainFlag) {
    case MainOpening: // ץ˥
      if (Opening() == True)
        return;
      break;
    case MainStart: // ơ
      Game(False);
      Start();
      break;
    case MainGame: // ץ쥤
      Game(True);
      // ݡå
      if (Root->Key & KPause)
	Root->MainFlag = MainPause;
      break;
    case MainPause: // ݡ
      Game(False);
      Root->MainFlag = (Root->Key & KShot) ? MainGame : MainPause;
      break;
    case MainClear: // ơꥢ
      Game(True);
      ClearAndGameOver();
      break;
    case MainGameOver: // ४С
      Game(True);
      ClearAndGameOver();
      break;
    case MainEnding: // ǥ
      break;
    }
    // åץǡ
    KXL_UpDate(rect);
  }
}

//========================================
// ΰ
//========================================
void CreateRoot(void)
{
  Uint16 i;

  // δ
  Root = (RootData *)KXL_Malloc(sizeof(RootData));
  // ʬ饯
  Root->My = (CharacterObject **)KXL_Malloc(sizeof(CharacterObject *) * MAX_MY);
  for (i = 0; i < MAX_MY; i ++)
    Root->My[i] = (CharacterObject *)KXL_Malloc(sizeof(CharacterObject));
  // Ũ饯
  Root->Your = (CharacterObject **)KXL_Malloc(sizeof(CharacterObject *) * MAX_YOUR);
  for (i = 0; i < MAX_YOUR; i ++)
    Root->Your[i] = (CharacterObject *)KXL_Malloc(sizeof(CharacterObject));
  // 󥭥󥰾
  Ranking = (RankingData **)KXL_Malloc(sizeof(RankingData *) * 5);
  for (i = 0; i < 5; i ++)
    Ranking[i] = (RankingData *)KXL_Malloc(sizeof(RankingData));
  // ɥ
  KXL_CreateWindow(WIDTH,
		   HEIGHT,
		   TITLE,
		   KXL_EVENT_KEY_PRESS_MASK |
		   KXL_EVENT_KEY_RELEASE_MASK);
  KXL_ReSizeFrame(PIC_WIDTH, PIC_HEIGHT);
  // 
  Root->MainFlag = MainOpening;
  ReadScore();
  Root->Key = KNone;
  Root->Stage =
  Root->Cnt = 0;
}

//========================================
// ΰ
//========================================
void DeleteRoot(void)
{
  Uint16 i;
  
  KXL_DeleteWindow();
  for (i = 0; i < MAX_MY; i ++)
    free(Root->My[i]);
  for (i = 0; i < MAX_YOUR; i ++)
    free(Root->Your[i]);
  free(Root);
  for (i = 0; i < 5; i ++)
    KXL_Free(Ranking[i]);
  KXL_Free(Ranking);
}

//========================================
// ץ
//========================================
void options(int argc, char **argv)
{
  Uint16 i;

  fprintf(stderr, "url   : http://www2.mwnet.or.jp/~fc3srx7\n");
  fprintf(stderr, "email : fc3srx7@mwnet.or.jp\n\n");
  for (i = 1; i < argc; i ++) {
    if (!strcmp(argv[i], "-h") || !strcmp(argv[i], "--help")) {
      fprintf(stderr, "\nUsage: geki5 [--display display] [--version] [--help]\n");
      fprintf(stderr, "--display display : Use display as the target display\n");
      fprintf(stderr, "--version         : Show version number and exit\n");
      fprintf(stderr, "--help            : Show this message\n");
      exit(1);
    }
  }
  fprintf(stderr, "\"geki5 --help\" for command line parameters\n");
  for (i = 1; i < argc; i ++) {
    if (!strcmp(argv[i], "--display")) {
      fprintf(stderr, "Using display: %s\n", argv[i + 1]);
      KXL_DisplayName(argv[i + 1]);
    }
    if (!strcmp(argv[i], "--version")) {
      fprintf(stderr, "Version is " TITLE "\n");
      exit(1);
    }
  }
}

//========================================
// ᥤ
//========================================
int main(int argc, char **argv)
{
  Uint8 *sname[]={
    "bgm",
    "bomb",
    "pow",
    "go",
    "hit",
    ""
  };

  // ץ
  options(argc, argv);
  // 
  srand(time(NULL));
  // ΰ
  CreateRoot();
  // ᡼
  CreateImage();
  // ɽ
  KXL_InitSound(WAV_PATH, sname);
  // ޳
  KXL_Timer(FRAME_RATE);
  // ᥤ롼
  MainLoop();
  // ɽλ
  KXL_EndSound();
  // ᡼
  DeleteImage();
  // ΰ
  DeleteRoot();
  return 0;
}
